"""
This type stub file was generated by pyright.
"""

from .base import Type

class ZippedDocumentBase(Type):
    def match(self, buf): # -> None:
        ...
    
    def match_document(self, buf):
        ...
    
    def compare_bytes(self, buf, subslice, start_offset): # -> Literal[False]:
        ...
    
    def search_signature(self, buf, start, rangeNum): # -> Literal[-1]:
        ...
    


class OpenDocument(ZippedDocumentBase):
    def match_document(self, buf): # -> Literal[False] | None:
        ...
    


class OfficeOpenXml(ZippedDocumentBase):
    def match_document(self, buf): # -> None:
        ...
    
    def match_filename(self, buf, offset): # -> None:
        ...
    


class Doc(Type):
    """
    Implements the Microsoft Word (Office 97-2003) document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    
    def match(self, buf): # -> bool:
        ...
    


class Docx(OfficeOpenXml):
    """
    Implements the Microsoft Word OOXML (Office 2007+) document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    


class Odt(OpenDocument):
    """
    Implements the OpenDocument Text document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    


class Xls(Type):
    """
    Implements the Microsoft Excel (Office 97-2003) document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    
    def match(self, buf): # -> bool:
        ...
    


class Xlsx(OfficeOpenXml):
    """
    Implements the Microsoft Excel OOXML (Office 2007+) document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    


class Ods(OpenDocument):
    """
    Implements the OpenDocument Spreadsheet document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    


class Ppt(Type):
    """
    Implements the Microsoft PowerPoint (Office 97-2003) document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    
    def match(self, buf): # -> bool:
        ...
    


class Pptx(OfficeOpenXml):
    """
    Implements the Microsoft PowerPoint OOXML (Office 2007+) document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    


class Odp(OpenDocument):
    """
    Implements the OpenDocument Presentation document type matcher.
    """
    MIME = ...
    EXTENSION = ...
    def __init__(self) -> None:
        ...
    


